import monitor.*;

//******************************************************************************/ 
// definizione di una classe che estende Monitor					/
//******************************************************************************/ 

public class PonteSemplice extends Monitor implements Ponte{

//******************************************************************************/ 
// dichiarazione delle variabili di stato del Monitor				/
//******************************************************************************/ 

    int nauto;	// numero di auto sul ponte
    int dircor;

//******************************************************************************/ 
// dichiarazione di variabili condition del Monitor		/
//******************************************************************************/ 

    Cond coda; 


//******************************************************************************/ 
// costruttore e inizializzazione delle variabili di stato del Monitor			/
//******************************************************************************/ 


    public PonteSemplice() {
    	nauto=0;
	dircor=1;
	coda = new Cond(this);
    }

//******************************************************************************/ 
// dichiarazione e definizione delle procedure di Entry sul Monitor		/
//******************************************************************************/ 

   public void Entra(int dir, String nomeMacchina) {

        // come prima istruzione bisogna invocare entraMonitor
        entraMonitor();

        if ( dircor != dir && nauto != 0)
        {
          System.out.println(nomeMacchina+" mi devo sospendere"); 
          coda.Wait();
        }
        else
        {
          System.out.println(nomeMacchina +" non mi sospendo");
        }
        nauto++;
        dircor = dir;

        // come ultima istruzione bisogna invocare esciMonitor
        esciMonitor();
    }

    public void Esci(int dir, String nomeMacchina) {

        // come prima istruzione bisogna invocare entraMonitor
        entraMonitor();

        System.out.println(nomeMacchina + " esce dal ponte");
        nauto--;
        if(nauto==0) 
          while (coda.queue()) coda.Signal();

        // come ultima istruzione bisogna invocare esciMonitor
        esciMonitor();
        }

}    // QUESTA GRAFFA TERMINA LA CLASSE MONITOR 
